

$( document ).ready(function() {
    
	var drop=$("#traveler_details").prop('outerHTML');
	$("#traveler_details").remove();
	$("body").append(drop);

	var drop_w=$("#travelers_group").width();
	$("#traveler_details").css("width", drop_w);

	var drop_x=$("#travelers_group").offset().left;
	var drop_y=$("#travelers_group").offset().top;

	$("#traveler_details").css('top', drop_y + $("#travelers_group").outerHeight());
	$("#traveler_details").css('left', drop_x);

	
	$("#btn-search").click(function(e){
		
		e.preventDefault();
		var roomEmpty=false;
		$(".rm-cnt").each(function(x){
			
			if ($(this).find("input[name='adults']").val()==0 && $(this).find("input[name='children']").val()==0){
				
				$("#room_error_"+x).text('please add 1 person or remove the room');
				roomEmpty=true;
			}
			
		});
		
		
		if (!roomEmpty){
		
			$("#formSearch").append("<div style='display:none'>");
			
			$("#traveler_details").find("input").each(function(){
				$("#formSearch").append($(this).prop('outerHTML'));
			});
			
			$("#formSearch").append("</div>");
			$("#formSearch").submit();
		
		}
		else return false;
			
	});

	/******************			DROPDOWN			****************/
	
    $("#travelers_group").click(function(e){
        
        $(".rc-dropdown-menu").slideToggle("fast");
        e.stopPropagation();
    });

    // Hide dropdown menu on click outside
    $(document).on("click", function(event){
        if(!$(event.target).closest("#traveler_details").length){
        	
        	
    		var roomEmpty=false;
    		$(".rm-cnt").each(function(x){
    		
    			if ($(this).find("input[name='adults']").val()==0 && $(this).find("input[name='children']").val()==0){
    			
    				$("#room_error_"+x).text('please add 1 person or remove the room');
    				roomEmpty=true;
    			}
    			
    		});
    	
    		
    		
    	
    		if (roomEmpty) return;
        	
            $(".rc-dropdown-menu").slideUp("fast");
            
            $("#travelers").val(getUpdatedText());
        }
    });
	
    $("#close_dropdown").on("click", function(event){
       	
    	
    		var roomEmpty=false;
    		$(".rm-cnt").each(function(x){
    		
    			if ($(this).find("input[name='adults']").val()==0 && $(this).find("input[name='children']").val()==0){
    			
    				$("#room_error_"+x).text('please add 1 person or remove the room');
    				roomEmpty=true;
    			}
    			
    		});
    	
    		
    		
    	
    		if (roomEmpty) return;
    		
            $(".rc-dropdown-menu").slideUp("fast");
            
            $("#travelers").val(getUpdatedText());
        
    });
    
    
    
    function getUpdatedText(){
    	
    	var rooms=0;
    	var adults=0;
    	var children=0;
    	$(".rm-cnt").each(function(){
    		
    		rooms++;
    		var target=($(this).attr("id")).split("_")[1];
     		
    		adults+=parseInt($("#adults_"+target).val(), 10);
    		children+=parseInt($("#children_"+target).val(), 10);
    		
    	});
    	
    	
    	
    	var text=""

    	
    	text+=adults;
    	
    	if (adults==1) text+=" "+str_adult;
    	else text+=" "+str_adults;
    	
    	if (children!=0) text+=" - ";
		
		if (children>1)text+=children+" "+str_children;
    	else if (children==1)text+="1 "+str_child;
    	return (text);    	

    	
    }

/******************			DATERANGE			****************/
    
    
language="en" //bg cz de en es fr hr hu it jp nl pl pt ru zh
calendar_open_side="right"; // right,left,top,bottom                                                                                              
column_start_day_of_week=1; // 0 to 6




$("#calendar_search_span").click(function(){
	$('#search_calendar').data('daterangepicker').show();
});

var today= new moment();
var tomorrow= new moment();
tomorrow=tomorrow.add(1,'days');


$("#checkin").val(today.format("YYYYMMDD"));
$("#checkout").val(tomorrow.format("YYYYMMDD"));
moment.locale(locale);
console.log("locale: "+moment.locale());

$('#search_calendar').daterangepicker({


	alwaysShowCalendars: true,
	startDate: today,
	endDate: tomorrow,
	minDate: today,
	opens: calendar_open_side,
    autoApply: true,
	disableHoverDate: true,
	locale: {
		format: "D MMM YY",
		monthNames: moment.months(),
        applyLabel: "APPLY",
        cancelLabel: "CANCEL",
        fromLabel: "FROM",
        toLabel: "TO",
        customRangeLabel: "CUSTOM RANGE",
        
        weekLabel: "WEEK",
        daysOfWeek: moment.weekdaysShort(),
        //CLAUDIO PRIMO GIORNO DELLA SETTIMANA DA CUI FAR PARTIRE IL CALENDARIO
        firstDay: column_start_day_of_week
	}
});


$('#search_calendar').on('hide.daterangepicker', function(ev, picker) {
	
	$("#search_group").removeClass("search_calendar_border");
	
	if(($("#search_calendar").data('daterangepicker').startDate.format("YYYY-MM-DD"))==($("#search_calendar").data('daterangepicker').endDate.format("YYYY-MM-DD"))){
		$("#search_calendar").val("");	
	}

	
	
});

$('#search_calendar').on('apply.daterangepicker', function(ev, picker) {
	

	$("#search_group").addClass("search_calendar_border_fixed");

	//remove pulse effect on checkin/checout calendar when a value is setted
	$(".dates_calendar").css("animation", "none");
	
	
	select_start=picker.startDate.format('YYYYMMDD');
	select_end=picker.endDate.format('YYYYMMDD');
	
	$("#checkin").val(select_start);
	$("#checkout").val(select_end);
	
	oneDay = 24 * 60 * 60 * 1000; 


	diffDays = Math.round(Math.abs(((picker.endDate - picker.startDate)) / oneDay));
	
	diffDays--;
	
	$("#cal_nights").text(diffDays);
	
	($("#formSearch").find($("#checkin"))).val(select_start);
	($("#formSearch").find($("#checkout"))).val(select_end);
	


	($("#formSearch").find($("#start_day"))).val($("#search_calendar").data('daterangepicker').startDate.format("DD"));
	($("#formSearch").find($("#start_month"))).val($("#search_calendar").data('daterangepicker').startDate.format("MM"));
	($("#formSearch").find($("#start_year"))).val($("#search_calendar").data('daterangepicker').startDate.format("YYYY"));
	
	($("#formSearch").find($("#end_day"))).val($("#search_calendar").data('daterangepicker').endDate.format("DD"));
	($("#formSearch").find($("#end_month"))).val($("#search_calendar").data('daterangepicker').endDate.format("MM"));
	($("#formSearch").find($("#end_year"))).val($("#search_calendar").data('daterangepicker').endDate.format("YYYY"));
											
	
	

	
	
});








/******************			GUEST BUTTONS + -			****************/



$(document).on('click','.box-btn-round', function() {

	

	
	btn_id=$(this).attr("id");

	
	// children and adults
	
		
		btn_target=btn_id.split("_")[0];
		btn_action=btn_id.split("_")[1];
		btn_target_room=btn_id.split("_")[2];
		
		$("#room_error_"+btn_target_room).text('');
		
	 if (btn_target=="age"){
		
		split=btn_id.split("_");
		 
		btn_target_room=split[1]+"_"+split[2]+"_"+split[3]+"_"+split[4];
		btn_action=split[5];
		
	}	
		
		//calculate new value
		new_val=parseInt($("#"+btn_target+"_"+btn_target_room).val(),10);

	
		if (isNaN(new_val)){
			new_val=0;
		}else{
			
			if (btn_action=="more")new_val+=1;
			
			if (btn_action=="less")new_val-=1;
			
			if (new_val<=-1)new_val=0;
							
			if (btn_target_room=="0" && btn_target=="adults" && new_val==0) new_val=1;

			if (btn_target_room!="0" && btn_target=="adults" && new_val==-1) new_val=0;

			
			if (new_val>=21) new_val=20;
			
			if (btn_target=="age" && new_val>=17){
				new_val=17;
			}
			
		}
		
		
		
		//apply disabled if necessary
		if (btn_target=="adults"){
			
			if (btn_target_room=="0"){
				if ($("#"+btn_target+"_"+btn_target_room).val()==2 && new_val==1) $("#"+btn_target+"_less_"+btn_target_room).addClass("disabled_btn");
				else if ($("#"+btn_target+"_"+btn_target_room).val()==1 && new_val==2) $("#"+btn_target+"_less_"+btn_target_room).removeClass("disabled_btn");
				
			}else{
				if ($("#"+btn_target+"_"+btn_target_room).val()==1 && new_val==0) $("#"+btn_target+"_less_"+btn_target_room).addClass("disabled_btn");
				else if ($("#"+btn_target+"_"+btn_target_room).val()==0 && new_val==1) $("#"+btn_target+"_less_"+btn_target_room).removeClass("disabled_btn");
			}				
			
		}
		if (btn_target=="children"){
			if ($("#"+btn_target+"_"+btn_target_room).val()==1 && new_val==0) $("#"+btn_target+"_less_"+btn_target_room).addClass("disabled_btn");
			else if ($("#"+btn_target+"_"+btn_target_room).val()==0 && new_val==1) $("#"+btn_target+"_less_"+btn_target_room).removeClass("disabled_btn");
		}
		if (btn_target=="age"){
			if ($("#"+btn_target+"_"+btn_target_room).val()==1 && new_val==0) $("#"+btn_target+"_"+btn_target_room+"_less").addClass("disabled_btn");
			else if ($("#"+btn_target+"_"+btn_target_room).val()==0 && new_val==1) $("#"+btn_target+"_"+btn_target_room+"_less").removeClass("disabled_btn");
		}
		
		if (btn_target=="adults" && $("#"+btn_target+"_"+btn_target_room).val()==19 && new_val==20) $("#"+btn_target+"_more_"+btn_target_room).addClass("disabled_btn");
		else if (btn_target=="adults" && $("#"+btn_target+"_"+btn_target_room).val()==20 && new_val==19) $("#"+btn_target+"_more_"+btn_target_room).removeClass("disabled_btn");

		if (btn_target=="age" && $("#"+btn_target).val()==16 && new_val==17) $("#"+btn_target+"_more").addClass("disabled_btn");
		else if (btn_target=="age" && $("#"+btn_target).val()==17 && new_val==16) $("#"+btn_target+"_more").removeClass("disabled_btn");
	
		//update children fields
		if (btn_target=="children") appendRemoveChildren(new_val,btn_action,btn_target_room);
		
		
			$("#"+btn_target+"_"+btn_target_room).val(new_val);
			$("#"+btn_target+"_span_"+btn_target_room).html(new_val);
		
		$(this).fadeTo(100, 0.5).fadeTo(100, 1.0);
		
		
	    $("#btn-resume").text(getUpdatedText());

});


function appendRemoveChildren(idx,action,btn_target_room){
	
	
	
	
	child_cnt=$(".app_child_cnt_"+btn_target_room).size();
	size=idx;
	
	
	
	if ("less"==action) size=child_cnt;
			
	
	for (k=0;k<size;k++){
		
		target_div=$("#room_"+btn_target_room+"_app_child_"+k);
		
		

		if (action=="more" && target_div.length==0){
			
			
			addChild(k,btn_target_room);
			
		}else if(action=="less" && k>=idx && target_div.length==1){
			
			target_div.remove();
			
		}
		
	}
	
	
	
}

function addChild(index,btn_target_room){
	
	html='<div class="rc-col-lg-6 rc-col-md-6 rc-col-sm-6 rc-col-xs-6 rc-text-center app_child_cnt_'+btn_target_room+'" id="room_'+btn_target_room+'_app_child_'+index+'">';


			html+='<div class=" rc-text-left inline-block div-room-ages-occupancy vert-align-middle">';
				html+='<i class="fa fa-child occupancy-icon src-occupancy-icon" aria-hidden="true" style="display: none;"></i>';
				html+='<span>'+str_age+' '+(index+1)+'</span>';
			html+='</div>';
			

			name="child_"; 	 
			child_trg=index;

				
			html+='<div class="rc-text-center inline-block div-room-ages-quantity">';
			
				html+='<span class="box-btn-round btn-less disabled_btn" id="age_room_'+btn_target_room+'_child_'+index+'_less">-</span>';
				html+='<div class="form-search-div inline-block">';
					html+='<span id="age_span_room_'+btn_target_room+'_child_'+index+'"  class="src-span">0</span>';

					html+='<input type="hidden" id="age_room_'+btn_target_room+'_child_'+index+'" name="'+name+child_trg+'" value="0"/>';
				html+='</div>';
				html+='<span class="box-btn-round btn-plus" id="age_room_'+btn_target_room+'_child_'+index+'_more" >+</span>';
				
			html+='</div>';		
								
				
		

	html+='</div>';

	
	
	$("#room_"+btn_target_room+"_children_append_container").append(html);
}






});
